---
layout: handbook-page-toc
title: Ops Sub-department
description: >-
  The Ops Sub-department is composed of development teams working on Verify,
  Package, Release, Configure, and Monitor features of GitLab DevOps Platform.
---

## On this page
{:.no_toc .hidden-md .hidden-lg}

- TOC
{:toc .hidden-md .hidden-lg}

![Ops Overview](/images/direction/ops/ops-overview.png)
<!-- source: https://docs.google.com/presentation/d/1606LcicYP-QKMjHHzTEvZSrx5qkW9LpHiKQUWlggdEk/edit#slide=id.g82767e51d3_1_0 -->
The Ops Sub-department is composed of development teams working on Verify, Package, Release, Configure, and Monitor features of GitLab DevOps Platform.

## Teams and Handbook Pages

The following teams comprise the sub-department:

- Verify stage - [handbook](/handbook/engineering/development/ops/verify/)
    - Pipeline Execution - [handbook](/handbook/engineering/development/ops/verify/pipeline-execution/), [jtbd](/handbook/engineering/development/ops/verify/pipeline-execution/jtbd/)
    - Pipeline Authoring - [handbook](/handbook/engineering/development/ops/verify/pipeline-authoring/), jtbd
    - Pipeline Insights - [handbook](/handbook/engineering/development/ops/verify/pipeline-insights/), [jtbd](/handbook/engineering/development/ops/verify/pipeline-insights/JTBD/)
    - Runner - [handbook](/handbook/engineering/development/ops/verify/runner/), jtbd
- Package stage - [handbook](/handbook/engineering/development/ops/package/)
    - Package - [handbook](/handbook/engineering/development/ops/package/), [jtbd](/handbook/engineering/development/ops/package/jtbd/)
- Release stage
    - Release - [handbook](/handbook/engineering/development/ops/release/), [jtbd](/handbook/engineering/development/ops/release/jtbd/)
- Configure stage
    - Configure - [handbook](/handbook/engineering/development/ops/configure/), jtbd
- Monitor stage - [handbook](/handbook/engineering/development/ops/monitor/)
    - Monitor:Respond - [handbook](/handbook/engineering/development/ops/monitor/respond/), jtbd
    - Monitor:Observability - [handbook](/handbook/engineering/development/ops/monitor/observability/), jtbd

## Product Direction

Product direction can be found on the [Ops Section Product Direction](/direction/ops/) handbook page.

## Performance Indicators

- [Ops Sub-department Performance Indicators](/handbook/engineering/metrics/ops/)
- [Error Budgets](/handbook/engineering/error-budgets/) as Performance Indicators for stage groups

### Dashboards

<%= partial "handbook/engineering/metrics/partials/_cross_functional_section_dashboard.erb", locals: { filter_value: "ops" } %>

## Slack channels

- [#ops-section](https://gitlab.slack.com/archives/CKW6KLB8F) - Ops Section discussions spanning the Verify, Package, Release, Configure, and Monitor Stages
- [#ops_staff_plus](https://gitlab.slack.com/archives/C0305PJB9JR) - Foster collaboration and technical leadership within Ops section
- [#doe-ops](https://gitlab.slack.com/archives/CT9CM1VDJ) - Channel for GitLab's Director of Engineering, Ops
- [🔒ops-staff-confidential](#private) - Channel for reviewing Ops promotion docs or sharing other confidential information.  Please use #doe-ops or #ops-section for topics that don’t require confidentiality.

## Meetings

Ops Sub-department regular meetings

| Meeting | Invitees (open to anyone) | DRI | Purpose | Cadence (duration) | Notes |
| ------- | ------------------------- | --- | ------- | ------------------ | ----- |
| Staff | Director and Direct Reports | Sam Goldstein | discuss and collaborate on group initiatives | weekly | [Agenda](https://docs.google.com/document/d/1LnFPO2_nmb7s1TvqsT3DGSXa1MEXkG4KDL8IO4NqXW8/edit#) |
| Skip-Level | Skip level EMs and ICs + People Business Partner | Sam Goldstein | roundtable discussion / opportunity to build connections across the group | monthly |  |
| Continuous Integration staff | Sr. Manager Verify + Managers | Cheryl Li | discuss group initiatives and announcements | bi-weekly (25 mins) |  |
| Continuous Delivery staff | Sr. Manager Continuous Delivery + Managers | Dan Croft | discuss group initiatives and announcements | bi-weekly (25 min / 50 mins) | 25 mins one week, 50 the next. People looking to learn about management can attend the 25 minute meeting. |
| Ops Engineering Showcase (formerly demos) | All engineering team members | Mark Nuzzo | Engineering-focused showcase of code and achievements | monthly (50 mins) | Mark Nuzzo coordinates the region [showcases](https://gitlab.com/groups/gitlab-com/-/epics/1157) for each month |
| Ops promotion reviews | Director, Sr. Managers, Managers | Sam Goldstein | Discussion and calibration on promotion documents for the quarter | Quarterly | We'll discuss an decide if we want to do this monthly and whether we want a post calibration meeting as well. |
| Ops Hiring Manager Sync | Hiring managers | Sam Goldstein | Support hiring manager efforts.  Updates and tracking of hiring activity.  Tricks and tips for effective hiring. | Weekly (25 min) | [Agenda](https://docs.google.com/document/d/1jl407WpUkPx9wc_ZQHGn77CywMURL9NS7ONWoLpGGds/edit) |

### Ops Engineering Showcase

Each month there are two showcase sessions organized for both APAC and AMER/EMEA timezones. These sessions are organized as opportunities for engineers to show off the things they've been working on. These sessions are each organized via a planning issue linked in the epic below. Sessions are recorded and uploaded to YouTube as well.

[Ops Engineering Showcase Epic](https://gitlab.com/groups/gitlab-com/-/epics/1157)

### Recordings 

| Year | Month | AMEA | APAC | Async videos |
| ------ | ------ | ------ | ------ | ------ |
| 2022 | November |  |  |  |
| 2022 | October | [Split GitLab Monolith into components](https://www.youtube.com/watch?v=cODM0xHqL28) | No showcases | [TaskScaler 101](https://www.youtube.com/watch?v=GU81g2oOtAQ) |
| 2022 | September | [Import packages with a CI pipeline](https://youtu.be/mk7gHFtUXpE)  | No showcases  |  |
| 2022 | August | No showcases | Async video -> | [Leader election in GitLab Agent for Kubernetes](https://youtu.be/Gz8NJJ2WFrE) | 
| 2022 | July | [Video](https://youtu.be/gkZ0Re9sfi8) | No showcases | [MR Coverage Report](https://drive.google.com/file/d/1cf2AxtMDTgcF3F1fWcHdIWJL1ps-S_oa/view) & [CI Workflows](https://youtu.be/cwfRI9m3rRs) | 
| 2022 | June | [Video](https://youtu.be/WLTHvv6z1B8) | [Video](https://youtu.be/YrFh7Dc0P2o) | [Demo](https://www.youtube.com/watch?v=7jEhyRBdQOM) |
| 2022 | May | [Video](https://www.youtube.com/watch?v=imi4MvUTqko) | No showcases | |
| 2022 | April | [Video](https://www.youtube.com/watch?v=cReKa3IvFTw) | [Video](https://youtu.be/cikmJS_CqqE)| |
| 2022 | March | [Video](https://youtu.be/4qmxGUh5GX0) | No showcases | |
| 2022 | February | [Video](https://youtu.be/HIT4UMwsf9U) | No showcases |  |
| 2022 | January | [Video](https://www.youtube.com/watch?v=ta-PXbO3zLY) | No showcases | [Jobs UI Refactor](https://www.youtube.com/watch?v=lJfjjbcEcFQ) |
| 2021 | December | [Video](https://youtu.be/rXHJHjEJZIk) | No showcases | |
| 2021 | November | [Video](https://youtu.be/bg-Dv9F_Sq4) | No showcases | |
| 2021 | October | [Video](https://www.youtube.com/watch?v=MOKr_4_0Rnc) | [Video](https://www.youtube.com/watch?v=60sLF3phB7g) | |
| 2020 | November | [Video](https://youtu.be/gkddYCRYdSk) | [Video](https://youtu.be/_nbAJODHyTs) | |
| 2020 | October | [Video](https://youtu.be/Abg5rCqRDVE) | Skipped | |
| 2020 | September | [Video](https://www.youtube.com/watch?v=hjHg_aG7Wr0) | [Video](https://www.youtube.com/watch?v=LUIdfAQf1B0) | |
| 2020 | August | [Video](https://www.youtube.com/watch?v=H47juOWB2F8) | [Video](https://www.youtube.com/watch?v=RABnrVmios0) | |

## Planning Processes

Planning processes followed by teams in the Sub-department:

- [General Ops Sub-department Planning Process](/handbook/engineering/development/ops/general-planning.html)

### Forced Priority planning/scheduling

Our [prioritization framework](/handbook/product/product-processes/#prioritization-framework) describes a number of [Forced Priority](https://about.gitlab.com/handbook/product/product-processes/#forced-prioritization) labels that present a high risk to our customers and our business. As such, it's critical that we complete this work within the appropriate SLO/SLAs where possible. An example of this are security issues, here's a dashboard for past due and soon to be due security issues: https://app.periscopedata.com/app/gitlab/913607/Past-Due-Security-Issues-Development

With this in mind, here's a process that groups are encouraged to use and iterate on in the event that they don't have an existing approach or are falling behind on SLA/SLOs.

To be clear, this is not a required process, if your group's approach is working, please continue with that! Ownership of scheduling forced priority work falls on our whole team, not a particular person.

1. When forced priority issues are assigned to your group, schedule those issues right away regardless of severity label
1. Have the team review the issue to make sure there's a viable solution and plan (weight the issue)
1. Have someone in the group assign themselves to work on the issue
1. Update the issue regularly with progress
1. Treat blockers with the same *or higher* priority than the original issue

## Ops Promotion Process

### Promotion Document Reviews

1. Team Member and Manager work together to create promotion document.
1. Promotion document is shared with Ops Sub-Department managers in #ops-staff-confidential channel (private to Ops Managers, Senior Managers, Director) to receive feedback on the document content and how it calibrates with others in the Sub-Department.  This can be done early and often.
1. Manager requests another Manager in the Sub-Department review and approve the document.
1. Manager requests Senior Manager in the Sub-Department review and approve the document.
1. Manager requests Director add Team Member to list of Sub-Department planned promotions.  If the team member cannot be added Director will provide feedback to Manager as to why.
1. Director presents promotion doc at Development Department quarterly promotion review meeting.  If the promotion is not approved Director will provide feedback to Manager as to why.

### Quarterly Promotion Review Meeting

Ops Managers, Sr. Managers, and Directors meet in the last month of each quarter to:

1. Review promotion projections for each group.  Managers add a list of their direct reports who they anticipate will be ready for promotion in the next 3 quarters to the meeting agenda.  *Note these lists may change and are not a guarantee a team member will be promoted in a specific quarter.  The lists are used for planning purposes, to help us anticipate the number of team members approaching promotion, budget impact, and to support calibration across the group.*
These lists should include:
    1. Team Member name
    1. Targeted promotion quarter
    1. Link to promotion doc 
    1. Whether the doc has received any Ops Manager or Ops Senior Manager approvals. 
1. Review Ops team member promotion docs planned to be presented at Development Department quarterly promotion review meeting.

## Ops Hiring process

We have limited capacity in the recruiting team so hiring managers are experimenting with the [Ops Hiring process](/handbook/engineering/development/ops/hiring-process/).  We also hold a weekly hiring manager sync meeting (see Meetings section).

## Objectives & Key Results (OKRs)

### Planning schedule

| OKR Schedule | Task |
| :----------- | :--- |
| 5 weeks before | OKR kickoff.  Quick sync to review schedule and expectations. Director Ops and direct reports. |
| 4 weeks before | Next Quarter OKR Planning - Initial Review Session - Director, SEMs, EMs - Review CEO, CTO, CProjO and VP Development OKR drafts |
| 3 weeks before | Next Quarter OKR Planning - 50 minute Director/SEM OKR review meeting. Ops Directors+, Sr. EMs, Group PMs propose OKRs for their groups in Working Drafts ([existing document](https://docs.google.com/document/d/1Auon_HTohhEdJiCJdXg_e8uHOHZapGmTSU5YPb58Chg/edit#) (internal)) |
| 2 weeks before | Next Quarter OKR Planning - 50 minute SEM/EM meeting for Verify and CD compartment.  EMs propose OKRs for their groups via issues linked from review meeting doc. |
| 1 week before | OKRs are moved into Ally. Directors, SEMs, EMs document how to achieve following guidance in https://about.gitlab.com/company/okrs/#documenting-how-to-achieve |
| 1 week before | OKRs and how to achieve docs are shared by DRIs in #doe-ops and other appropriate slack channels. |
| 1st week of quarter | Ops Sub-Dept OKR AMA.  25 minute kickoff meeting to discuss OKRs and answer questions. |

### Creating OKRs

- Target a 70% completion rate for OKRs so that we are setting goals ambitiously. They should be challenging enough that [accomplishing 100% is a stretch goal,since GitLab considers OKRs to be stretch goals by default](https://about.gitlab.com/company/okrs/#okrs-are-stretch-goals-by-default).
- If your OKRs are associated with any specific types of issues, consider reviewing the [prioritization framework](https://about.gitlab.com/handbook/product/product-processes/#prioritization), and align with your team on your OKRs priority relative to one another (for example, OKRs with issues with "forced prioritization") and be clear on planning of the associated work over the quarter.
- Ensure Key Results (KRs) are measurable, by specifying a number (% or unit) as the target. Be clear on the starting number, and the expected end result (e.g. `from x to y`).
- Ideally create no more than 9 KRs per quarter, ideally with approximately 3 KR per objective. 

### Tracking and completing OKRs

- DRIs are expected to score OKRs on a regular basis, at least monthly, if possible.
- At the end of the quarter, DRIs can add a retrospective as a comment to reflect on the progress of their KR, in the following format:

```
**Good**
- Things that went well...

**Bad**
- Things that didn't go so well...

**Try**
- What might you do differently next time?
```

## Async Updates (No Status In Meetings)

We have a policy in Ops to keep status updates out of meetings. Instead of reporting on status in meetings Directors, Senior Engineering Managers, Engineering Managers and Principal Engineers provide regular async updates.  

The content of these updates varies by individual and role:

### Async Update Guidance

#### Engineering Manager

1. Cadence: Weekly
1. Topics:
    1. Highlights & Accomplishments
    1. Team Projects & Priorities (progress, blockers, key decisions, etc.)
    1. Team Health (team dynamic, team morale, hiring, team concerns, etc.)
    1. Team Metrics and SLAs (e.g. Security SLAs, etc.)
    1. Other Announcements & topics of interest to those reading the report

#### Senior Engineering Manager

1. Cadence: Monthly
1. Topics:
    1. Milestone Review
        1. Allocation of focus in milestone plans (major features, maintenance, etc.)
        1. What tradeoffs or decisions should be made prior to Milestone kickoff? For example:
            1. Is the team overcommitted?
            1. Does the allocation of effort need to shift to meet specific goals? (e.g. Security SLAs)

#### Principal Engineer

1. Cadence: Weekly
1. Topics: 
    1. Highlights & Accomplishments
    1. Projects & Priorities (progress, blockers, key decisions, etc.)

#### Director

1. Cadence: Monthly
1. Topics: 
    1. Summary of Highlights & Accomplishments across the section

### To create a weekly async update:

1. Create a GitLab issue in any project.
2. Apply the label `~OpsSection::AsyncUpdate`.  (The label `~OpsSection::Weekly-Update` can also be used for backwards compatibility reasons.)
3. Choose a descriptive title.  Include your update in the issue description.

### To HIGHLIGHT an item for inclusion in the Director update

1. Begin any paragraph in your update with the text `HIGHLIGHT:`
1. These paragraphs will automatically be copied into the Highlights & Accomplishments section of the monthly Director's update.

### To review Ops weekly async updates:

1. All issues with the `~OpsSection::AsyncUpdate` or `~OpsSection::Weekly-Update` label are summarized in weekly issues in the [Ops Status Updates](https://gitlab.com/gitlab-com/ops-sub-department/ops-status-updates/-/issues) project.
1. All team members are encouraged to comment and ask questions in weekly async update issues.  This provides useful feedback to the author and opportunities to collaborate.
1. Director reviews all updates weekly (from the prior week) and provides feedback.
1. Senior EMs reviews all updates from their teams weekly (from the prior week) and provides feedback.

### Benefits of reporting and reviewing status async vs. synchronously in meetings:

1. Collaboration - By sharing announcements, achievements, goals, and plans we are empowering team members with the information they need to make sound decisions and succeed in their roles.
1. Results - Async updates provide an important channel for sharing accomplishments and progress.
1. Efficiency - Expecting each team member to [poll](https://en.wikipedia.org/wiki/Polling_(computer_science)) for the status they need is extremely inefficient and becomes more inefficient as the organization grows. By using a [Publish Subscribe model](https://en.wikipedia.org/wiki/Publish%E2%80%93subscribe_pattern) we are able to share information much more efficiently.
1. Diversity, Inclusion & Belonging - Async status is more inclusive of team members across timezones.  Not every team member will be able to make a sync meeting (due to timezone or other factors) but everyone can participate in an async update.
1. Iteration - Taking the time to checkpoint where we are at each week prompts the author and readers to consider ways to iterate and to reflect on incremental progress.
1. Transparency - Sharing information in a consistent, accessible way increases transparency and reduces the threshold for team members to contribute.


## Escalations from Support Team 

We are piloting a process to make coordinating with the Support team on customer escalations more efficient.

See [How to Use GitLab.com to Formally Request Help from the GitLab Ops Development Team](https://about.gitlab.com/handbook/support/workflows/how-to-get-help.html#how-to-use-gitlabcom-to-formally-request-help-from-the-gitlab-ops-development-team) for process details.
